/******************************************************************************
*                                                                             *
*    romaji.c                               Copyright(c) 2004-2007 itow,y.    *
*                                                                             *
******************************************************************************/


#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <tchar.h>
#include "diblib.h"
#include "resource.h"


#define MAIN_WINDOW_WIDTH	640				/* EBhE̕ */
#define MAIN_WINDOW_HEIGHT	480				/* EBhE̍ */

/* ȕ̒ */
#ifndef UNICODE
#define KANA_LENGTH 2
#else
#define KANA_LENGTH 1
#endif

#define CP_SJIS 932							/* Shift_JIS ̃R[hy[W */

#define MAX_WORD_LENGTH			32			/* P̍ő啶 */
#define MAX_WORD_ALPHA_LENGTH	((MAX_WORD_LENGTH-1)*3+1)
										/* P̃At@xbg̍ő啶 */

#define Random(n) (rand()%(n))


/* CEBhẼEBhENX */
#define MAIN_WINDOW_CLASS TEXT("Romaji lesson main window")

static HINSTANCE hInst;						/* CX^Xnh */
static HWND hwndMain=NULL;					/* CEBhEnh */

static int nMainWindowLeft=CW_USEDEFAULT;	/* EBhEʒu */
static int nMainWindowTop=CW_USEDEFAULT;	/* EBhEʒu */

static DIBInfo *pdibWindow=NULL;			/* EBhEp摜 */
static DIBInfo *pdibTitle=NULL;				/* ^Cg摜 */
static DIBInfo *pdibKeyboard=NULL;			/* L[{[h摜 */
static DIBInfo *pdibHand=NULL;				/* 摜 */

static BOOL fPlaying=FALSE;					/* K */
static int nCurLesson=-1;					/* ݂̗K */
static LPCTSTR pszCurWord=NULL;				/* ݂̒P */
static int nCurLetter;						/* ݂̕ */
static TCHAR szCurWordAlpha[MAX_WORD_ALPHA_LENGTH];
											/* ݂̒P̃At@xbg */
static int nCurAlphaLetter;					/* ݂̃At@xbg̕ */
static int nNextLetterOffset[MAX_WORD_ALPHA_LENGTH];
											/* ̂Ȃւ̃ItZbg */

static int nWordTop,nWordLeft;				/* ̈ʒu */
static int nAlphaTop,nAlphaLeft;			/* At@xbg̈ʒu */
static int nKeyboardTop,nKeyboardLeft;		/* L[{[ḧʒu */

static LOGFONT lfTextFont;					/* tHg */
static int nFontSize=32;					/* tHg̑傫 */
static HFONT hfontText;						/* tHg̃nh */
static COLORREF crTextColor=RGB(128,128,128);			/* F */
static COLORREF crHighlightTextColor=RGB(128,128,255);	/* F */
static COLORREF crBackgroundColor=RGB(240,255,240);		/* wiF */

static BOOL fShowKeyboard=TRUE;				/* L[{[h̕\ */

static TCHAR szLessonWordsFileName[MAX_PATH];	/* PKpt@C */
static LPTSTR *ppszLessonWordList=NULL;		/* PK̒P */
static int nNumLessonWords=0;				/* PA̒P̐ */

/* ƃL[̈ʒȗΉ\ */
static const struct {
	int x,y;
} KeyPos[] = {
	{ 0, 4},{ 0, 0},{ 1, 0},{ 2, 0},{ 3, 0},{ 4, 0},{ 5, 0},{ 6, 0},
	{ 7, 0},{ 8, 0},{10, 2},{ 9, 2},{ 7, 3},{10, 0},{ 8, 3},{ 9, 3},
	{ 9, 0},{ 0, 0},{ 1, 0},{ 2, 0},{ 3, 0},{ 4, 0},{ 5, 0},{ 6, 0},
	{ 7, 0},{ 8, 0},{10, 2},{ 9, 2},{ 7, 3},{10, 0},{ 8, 3},{ 9, 3},
	{10, 1},{ 0, 2},{ 4, 3},{ 2, 3},{ 2, 2},{ 2, 1},{ 3, 2},{ 4, 2},
	{ 5, 2},{ 7, 1},{ 6, 2},{ 7, 2},{ 8, 2},{ 6, 3},{ 5, 3},{ 8, 1},
	{ 9, 1},{ 0, 1},{ 3, 1},{ 1, 2},{ 4, 1},{ 6, 1},{ 3, 3},{ 1, 1},
	{ 1, 3},{ 5, 1},{ 0, 3},{11, 1},{12, 0},{11, 2},{11, 0},{10, 3},
	{10, 1},{ 0, 2},{ 4, 3},{ 2, 3},{ 2, 2},{ 2, 1},{ 3, 2},{ 4, 2},
	{ 5, 2},{ 7, 1},{ 6, 2},{ 7, 2},{ 8, 2},{ 6, 3},{ 5, 3},{ 8, 1},
	{ 9, 1},{ 0, 1},{ 3, 1},{ 1, 2},{ 4, 1},{ 6, 1},{ 3, 3},{ 1, 1},
	{ 1, 3},{ 5, 1},{ 0, 3},{11, 1},{12, 0},{11, 2},{11, 0}
};

/* ẪJX^}CYp */
static enum {KEY_SI,KEY_SHI} SiKey=KEY_SI;
static enum {KEY_TI,KEY_CHI} TiKey=KEY_TI;
static enum {KEY_TU,KEY_TSU} TuKey=KEY_TU;
static enum {KEY_HU,KEY_FU} HuKey=KEY_HU;
static enum {KEY_ZI,KEY_JI} ZiKey=KEY_ZI;
static enum {KEY_SYA,KEY_SHA} SyaKey=KEY_SYA;
static enum {KEY_SYU,KEY_SHU} SyuKey=KEY_SYU;
static enum {KEY_SYE,KEY_SHE} SyeKey=KEY_SYE;
static enum {KEY_SYO,KEY_SHO} SyoKey=KEY_SYO;
static enum {KEY_JYA,KEY_ZYA,KEY_JA} JyaKey=KEY_JYA;
static enum {KEY_JYI,KEY_ZYI} JyiKey=KEY_JYI;
static enum {KEY_JYU,KEY_ZYU,KEY_JU} JyuKey=KEY_JYU;
static enum {KEY_JYE,KEY_ZYE,KEY_JE} JyeKey=KEY_JYE;
static enum {KEY_JYO,KEY_ZYO,KEY_JO} JyoKey=KEY_JYO;
static enum {KEY_TYA,KEY_CYA,KEY_CHA} TyaKey=KEY_TYA;
static enum {KEY_TYI,KEY_CYI} TyiKey=KEY_TYI;
static enum {KEY_TYU,KEY_CYU,KEY_THU} TyuKey=KEY_TYU;
static enum {KEY_TYE,KEY_CYE,KEY_THE} TyeKey=KEY_TYE;
static enum {KEY_TYO,KEY_CYO,KEY_THO} TyoKey=KEY_TYO;
static enum {KEY_FI,KEY_FYI} FiKey=KEY_FI;
static enum {KEY_FE,KEY_FYE} FeKey=KEY_FE;
static enum {KEY_LA,KEY_XA} LaKey=KEY_LA;
static enum {KEY_LI,KEY_XI} LiKey=KEY_LI;
static enum {KEY_LU,KEY_XU} LuKey=KEY_LU;
static enum {KEY_LE,KEY_XE} LeKey=KEY_LE;
static enum {KEY_LO,KEY_XO} LoKey=KEY_LO;
static enum {KEY_LTU,KEY_XTU} LtuKey=KEY_LTU;
static enum {KEY_LYA,KEY_XYA} LyaKey=KEY_LYA;
static enum {KEY_LYU,KEY_XYU} LyuKey=KEY_LYU;
static enum {KEY_LYO,KEY_XYO} LyoKey=KEY_LYO;




static LPTSTR GetFileNamePtr(LPTSTR pszPath)
{
	LPTSTR p=pszPath,pszDelim=NULL;

	while (*p!='\0') {
#ifndef UNICODE
		if (IsDBCSLeadByteEx(CP_ACP,*p)) {
			p+=2;
			continue;
		}
#endif
		if (*p=='\\')
			pszDelim=p;
		p++;
	}
	return pszDelim!=NULL?pszDelim+1:pszPath;
}


static BOOL FileExists(LPCTSTR pszFileName)
{
	HANDLE hFind;
	WIN32_FIND_DATA fd;

	hFind=FindFirstFile(pszFileName,&fd);
	if (hFind!=INVALID_HANDLE_VALUE) {
		FindClose(hFind);
		return TRUE;
	}
	return FALSE;
}


static void LoadSettings(LPCTSTR pszFileName)
{
	nMainWindowLeft=GetPrivateProfileInt(_T("Settings"),_T("WindowLeft"),
												nMainWindowLeft,pszFileName);
	nMainWindowTop=GetPrivateProfileInt(_T("Settings"),_T("WindowTop"),
												nMainWindowTop,pszFileName);
	fShowKeyboard=(BOOL)GetPrivateProfileInt(_T("Settings"),_T("ShowKeyboard"),
													fShowKeyboard,pszFileName);
	lfTextFont.lfHeight=GetPrivateProfileInt(_T("Font"),_T("Height"),
											lfTextFont.lfHeight,pszFileName);
	lfTextFont.lfWidth=GetPrivateProfileInt(_T("Font"),_T("Width"),
											lfTextFont.lfWidth,pszFileName);
	lfTextFont.lfEscapement=GetPrivateProfileInt(_T("Font"),_T("Escapement"),
										lfTextFont.lfEscapement,pszFileName);
	lfTextFont.lfOrientation=GetPrivateProfileInt(_T("Font"),_T("Orientation"),
										lfTextFont.lfOrientation,pszFileName);
	lfTextFont.lfWeight=GetPrivateProfileInt(_T("Font"),_T("Weight"),
											lfTextFont.lfWeight,pszFileName);
	lfTextFont.lfItalic=(BYTE)GetPrivateProfileInt(_T("Font"),_T("Italic"),
											lfTextFont.lfItalic,pszFileName);
	lfTextFont.lfUnderline=(BYTE)GetPrivateProfileInt(_T("Font"),
						_T("Underline"),lfTextFont.lfUnderline,pszFileName);
	lfTextFont.lfStrikeOut=(BYTE)GetPrivateProfileInt(_T("Font"),
						_T("StrikeOut"),lfTextFont.lfStrikeOut,pszFileName);
	lfTextFont.lfCharSet=(BYTE)GetPrivateProfileInt(_T("Font"),_T("CharSet"),
											lfTextFont.lfCharSet,pszFileName);
	lfTextFont.lfOutPrecision=(BYTE)GetPrivateProfileInt(_T("Font"),
					_T("OutPrecision"),lfTextFont.lfOutPrecision,pszFileName);
	lfTextFont.lfClipPrecision=(BYTE)GetPrivateProfileInt(_T("Font"),
				_T("ClipPrecision"),lfTextFont.lfClipPrecision,pszFileName);
	lfTextFont.lfQuality=(BYTE)GetPrivateProfileInt(_T("Font"),_T("Quality"),
											lfTextFont.lfQuality,pszFileName);
	lfTextFont.lfPitchAndFamily=(BYTE)GetPrivateProfileInt(_T("Font"),
				_T("PitchAndFamily"),lfTextFont.lfPitchAndFamily,pszFileName);
	GetPrivateProfileString(_T("Font"),_T("FaceName"),lfTextFont.lfFaceName,
								lfTextFont.lfFaceName,LF_FACESIZE,pszFileName);
	nFontSize=GetPrivateProfileInt(_T("Font"),_T("Size"),nFontSize,
																pszFileName);
	SiKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Si"),SiKey,pszFileName);
	TiKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Ti"),TiKey,pszFileName);
	TuKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Tu"),TuKey,pszFileName);
	HuKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Hu"),HuKey,pszFileName);
	ZiKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Zi"),ZiKey,pszFileName);
	SyaKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Sya"),SyaKey,pszFileName);
	SyuKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Syu"),SyuKey,pszFileName);
	SyeKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Sye"),SyeKey,pszFileName);
	SyoKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Syo"),SyoKey,pszFileName);
	JyaKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Jya"),JyaKey,pszFileName);
	JyiKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Jyi"),JyiKey,pszFileName);
	JyuKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Jyu"),JyuKey,pszFileName);
	JyeKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Jye"),JyeKey,pszFileName);
	JyoKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Jyo"),JyoKey,pszFileName);
	TyaKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Tya"),TyaKey,pszFileName);
	TyiKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Tyi"),TyiKey,pszFileName);
	TyuKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Tyu"),TyuKey,pszFileName);
	TyeKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Tye"),TyeKey,pszFileName);
	TyoKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Tyo"),TyoKey,pszFileName);
	FiKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Fi"),FiKey,pszFileName);
	FeKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Fe"),FeKey,pszFileName);
	LaKey=GetPrivateProfileInt(_T("KeyConfig"),_T("La"),LaKey,pszFileName);
	LiKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Li"),LiKey,pszFileName);
	LuKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Lu"),LuKey,pszFileName);
	LeKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Le"),LeKey,pszFileName);
	LoKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Lo"),LoKey,pszFileName);
	LtuKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Ltu"),LtuKey,pszFileName);
	LyaKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Lya"),LyaKey,pszFileName);
	LyuKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Lyu"),LyuKey,pszFileName);
	LyoKey=GetPrivateProfileInt(_T("KeyConfig"),_T("Lyo"),LyoKey,pszFileName);
}


static BOOL WritePrivateProfileInt(LPCTSTR pszSection,LPCTSTR pszKey,
												int nValue,LPCTSTR pszFileName)
{
	TCHAR szValue[12];

	wsprintf(szValue,TEXT("%d"),nValue);
	return WritePrivateProfileString(pszSection,pszKey,szValue,pszFileName);
}


static void SaveSettings(LPCTSTR pszFileName)
{
	WritePrivateProfileInt(_T("Settings"),_T("WindowLeft"),nMainWindowLeft,
																pszFileName);
	WritePrivateProfileInt(_T("Settings"),_T("WindowTop"),nMainWindowTop,
																pszFileName);
	WritePrivateProfileInt(_T("Settings"),_T("ShowKeyboard"),fShowKeyboard,
																pszFileName);
	WritePrivateProfileInt(_T("Settings"),_T("TextColor"),crTextColor,
																pszFileName);
	WritePrivateProfileInt(_T("Settings"),_T("HighlightTextColor"),
											crHighlightTextColor,pszFileName);
	WritePrivateProfileInt(_T("Settings"),_T("BackgroundColor"),
												crBackgroundColor,pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("Height"),lfTextFont.lfHeight,
																pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("Width"),lfTextFont.lfWidth,
																pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("Escapement"),lfTextFont.lfEscapement,
																pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("Orientation"),
										lfTextFont.lfOrientation,pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("Weight"),lfTextFont.lfWeight,
																pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("Italic"),lfTextFont.lfItalic,
																pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("Underline"),lfTextFont.lfUnderline,
																pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("StrikeOut"),lfTextFont.lfStrikeOut,
																pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("CharSet"),lfTextFont.lfCharSet,
																pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("OutPrecision"),
										lfTextFont.lfOutPrecision,pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("ClipPrecision"),
									lfTextFont.lfClipPrecision,pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("Quality"),lfTextFont.lfQuality,
																pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("PitchAndFamily"),
									lfTextFont.lfPitchAndFamily,pszFileName);
	WritePrivateProfileString(_T("Font"),_T("FaceName"),lfTextFont.lfFaceName,
																pszFileName);
	WritePrivateProfileInt(_T("Font"),_T("Size"),nFontSize,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Si"),SiKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Ti"),TiKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Tu"),TuKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Hu"),HuKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Zi"),ZiKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Sya"),SyaKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Syu"),SyuKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Sye"),SyeKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Syo"),SyoKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Jya"),JyaKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Jyi"),JyiKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Jyu"),JyuKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Jye"),JyeKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Jyo"),JyoKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Tya"),TyaKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Tyi"),TyiKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Tyu"),TyuKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Tye"),TyeKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Tyo"),TyoKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Fi"),FiKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Fe"),FeKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("La"),LaKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Li"),LiKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Lu"),LuKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Le"),LeKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Lo"),LoKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Ltu"),LtuKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Lya"),LyaKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Lyu"),LyuKey,pszFileName);
	WritePrivateProfileInt(_T("KeyConfig"),_T("Lyo"),LyoKey,pszFileName);
}


static int CountWords(LPCSTR pszText)
{
	LPCSTR p=pszText;
	int nCount=0;
	int nLength;

	while (*p!='\0') {
		if (*p=='\r' || *p=='\n') {
			p++;
		} else {
			nLength=0;
			do {
				if (IsDBCSLeadByteEx(CP_SJIS,*p)) {
					if (*(p+1)=='\0')
						break;
					p+=2;
					nLength++;
				} else
					break;
			} while (*p!='\0' && *p!='\r' && *p!='\n');
			if (nLength>0 && nLength<MAX_WORD_LENGTH)
				nCount++;
		}
	}
	return nCount;
}


static BOOL GetWords(LPTSTR *ppszWords,int nNumWords,LPCSTR pszText)
{
	int i;
	LPCSTR p=pszText,pszFirst;
	int nLength;

	for (i=0;i<nNumWords;i++) {
		while (*p=='\r' || *p=='\n')
			p++;
		pszFirst=p;
		do {
			if (IsDBCSLeadByteEx(CP_SJIS,*p)) {
				if (*(p+1)=='\0')
					break;
				p+=2;
			} else
				break;
		} while (*p!='\0' && *p!='\r' && *p!='\n');
		nLength=p-pszFirst;
		if (nLength>0 && nLength/2<MAX_WORD_LENGTH) {
#ifdef UNICODE
			nLength=MultiByteToWideChar(CP_SJIS,0,pszFirst,nLength,NULL,0);
#endif
			ppszWords[i]=malloc((nLength+1)*sizeof(TCHAR));
			if (ppszWords[i]==NULL) {
				for (i--;i>=0;i--)
					free(ppszWords[i]);
				return FALSE;
			}
#ifndef UNICODE
			memcpy(ppszWords[i],pszFirst,nLength);
			ppszWords[i][nLength]='\0';
#else
			MultiByteToWideChar(CP_SJIS,0,pszFirst,p-pszFirst,ppszWords[i],
																	nLength+1);
#endif
		}
	}
	return TRUE;
}


static BOOL LoadLessonWords(LPCTSTR pszFileName,LPTSTR **pppszWords,
															int *pnNumWords)
{
	HANDLE hFile;
	DWORD dwFileSize,dwRead;
	LPSTR p;

	hFile=CreateFile(pszFileName,GENERIC_READ,FILE_SHARE_READ,NULL,
									OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (hFile==INVALID_HANDLE_VALUE)
		return FALSE;
	dwFileSize=GetFileSize(hFile,NULL);
	if (dwFileSize==0) {
		CloseHandle(hFile);
		return FALSE;
	}
	p=(LPSTR)malloc(dwFileSize+1);
	if (p==NULL) {
		CloseHandle(hFile);
		return FALSE;
	}
	if (!ReadFile(hFile,p,dwFileSize,&dwRead,NULL) || dwRead!=dwFileSize) {
		free(p);
		CloseHandle(hFile);
		return FALSE;
	}
	p[dwFileSize]='\0';
	CloseHandle(hFile);
	*pnNumWords=CountWords(p);
	if (*pnNumWords==0) {
		free(p);
		return FALSE;
	}
	(*pppszWords)=(LPTSTR*)malloc(*pnNumWords*sizeof(LPTSTR));
	if (*pppszWords==NULL) {
		free(p);
		return FALSE;
	}
	if (!GetWords(*pppszWords,*pnNumWords,p)) {
		free(p);
		free(*pppszWords);
		*pppszWords=NULL;
		return FALSE;
	}
	free(p);
	return TRUE;
}


static void FreeLessonWords(LPTSTR *ppszWords,int nNumWords)
{
	int i;

	for (i=nNumWords-1;i>=0;i--)
		free(ppszWords[i]);
	free(ppszWords);
}


static void Redraw(int nLeft,int nTop,int nWidth,int nHeight,BOOL fUpdate)
{
	RECT rc;

	rc.left=nLeft;
	rc.top=nTop;
	rc.right=nLeft+nWidth;
	rc.bottom=nTop+nHeight;
	InvalidateRect(hwndMain,&rc,TRUE);
	if (fUpdate)
		UpdateWindow(hwndMain);
}


static void DrawKeyboard(BOOL fRedraw)
{
	nKeyboardLeft=(MAIN_WINDOW_WIDTH-pdibKeyboard->nWidth)/2;
	nKeyboardTop=MAIN_WINDOW_HEIGHT/2+
							(MAIN_WINDOW_HEIGHT/2-(pdibKeyboard->nHeight/2))/2;
	DIB_Copy(pdibWindow,nKeyboardLeft,nKeyboardTop,pdibKeyboard->nWidth,
									pdibKeyboard->nHeight/2,pdibKeyboard,0,0,
									DIB_OPACITY_OPAQUE,DIB_COPY_TRANSPARENT);
	if (fRedraw)
		Redraw(nKeyboardLeft,nKeyboardTop,pdibKeyboard->nWidth,
												pdibKeyboard->nHeight/2,TRUE);
}


static void HighlightKeyboard(int nKey,BOOL fHighlight,BOOL fRedraw)
{
	int i,x,y;

	i=nKey-0x20;
	if (i<0 || i>=sizeof(KeyPos)/sizeof(KeyPos[0]))
		return;
	y=KeyPos[i].y*32;
	switch (KeyPos[i].y) {
	case 0:	x=32;	break;
	case 1:	x=48;	break;
	case 2:	x=60;	break;
	case 3:	x=76;	break;
	case 4:
		/* Space */
		DIB_Copy(pdibWindow,nKeyboardLeft+172,nKeyboardTop+y,136,32,
									pdibKeyboard,172,!fHighlight?128:160+128,
									DIB_OPACITY_OPAQUE,DIB_COPY_TRANSPARENT);
		if (fRedraw)
			Redraw(nKeyboardLeft+172,nKeyboardTop+y,136,32,TRUE);
		return;
	}
	x+=KeyPos[i].x*32;
	DIB_Copy(pdibWindow,nKeyboardLeft+x,nKeyboardTop+y,32,32,
									pdibKeyboard,x,(fHighlight?y+160:y),
									DIB_OPACITY_OPAQUE,DIB_COPY_TRANSPARENT);
	if (fRedraw)
		Redraw(nKeyboardLeft+x,nKeyboardTop+y,32,32,TRUE);
}


static void DrawHand(BOOL fRedraw)
{
	int x,y,i;

	y=MAIN_WINDOW_HEIGHT-56;
	x=nKeyboardLeft;
	DIB_Copy(pdibWindow,x,y,pdibHand->nWidth,pdibHand->nHeight/2,pdibHand,0,0,
									DIB_OPACITY_OPAQUE,DIB_COPY_TRANSPARENT);
	if (fRedraw)
		Redraw(x,y,pdibHand->nWidth,pdibHand->nHeight/2,TRUE);
	x=nKeyboardLeft+pdibKeyboard->nWidth-pdibHand->nWidth;
	for (i=0;i<5;i++)
		DIB_Copy(pdibWindow,x+i*32,y,32,56,pdibHand,(4-i)*32,0,
									DIB_OPACITY_OPAQUE,DIB_COPY_TRANSPARENT);
	if (fRedraw)
		Redraw(x,y,pdibHand->nWidth,pdibHand->nHeight/2,TRUE);
}


static int GetFinger(int nChar)
{
	int i=nChar-0x20;

	if (KeyPos[i].y==4)
		return 4;
	if (KeyPos[i].x<=3)
		return KeyPos[i].x;
	if (KeyPos[i].x==4)
		return 3;
	if (KeyPos[i].x==5)
		return 6;
	if (KeyPos[i].x>=10)
		return 9;
	return KeyPos[i].x;
}


static void HighlightHand(int nFinger,BOOL fHighlight,BOOL fRedraw)
{
	int x,y;

	y=MAIN_WINDOW_HEIGHT-56;
	if (nFinger==4 || nFinger==5) {
		/* Thumb */
		int x1,x2;

		x1=nKeyboardLeft+4*32;
		x2=nKeyboardLeft+pdibKeyboard->nWidth-5*32;
		DIB_Copy(pdibWindow,x1,y,32,56,pdibHand,128,fHighlight?56:0,
									DIB_OPACITY_OPAQUE,DIB_COPY_TRANSPARENT);
		DIB_Copy(pdibWindow,x2,y,32,56,pdibHand,128,fHighlight?56:0,
									DIB_OPACITY_OPAQUE,DIB_COPY_TRANSPARENT);
		if (fRedraw) {
			Redraw(x1,y,32,56,TRUE);
			Redraw(x2,y,32,56,TRUE);
		}
		return;
	}
	if (nFinger<4) {
		x=nKeyboardLeft+nFinger*32;
		DIB_Copy(pdibWindow,x,y,32,56,pdibHand,nFinger*32,fHighlight?56:0,
									DIB_OPACITY_OPAQUE,DIB_COPY_TRANSPARENT);
	} else {
		x=nKeyboardLeft+pdibKeyboard->nWidth-5*32+(nFinger-5)*32;
		DIB_Copy(pdibWindow,x,y,32,56,pdibHand,(4-(nFinger-5))*32,
					fHighlight?56:0,DIB_OPACITY_OPAQUE,DIB_COPY_TRANSPARENT);
	}
	if (fRedraw)
		Redraw(x,y,32,56,TRUE);
}


static void GetWordAlpha(LPCTSTR pszWord,LPTSTR pszAlpha,int *pnOffset)
{
	static const LPCTSTR pszVowel=TEXT("AIUEO");
	LPCTSTR p=pszWord,pszPrevLetter;
	LPTSTR q=pszAlpha,pszPrevAlpha;
	WORD wChar,wNextChar;
	int i,j;
	BOOL fLtuMode=FALSE;

	i=0;
	while (*p!='\0') {
#ifndef UNICODE
		wChar=((WORD)(BYTE)p[0]<<8)|(BYTE)p[1];
		if (p[2]!='\0')
			wNextChar=((WORD)(BYTE)p[2]<<8)|(BYTE)p[3];
		else
			wNextChar=0;
#else
		char szChar[3];

		WideCharToMultiByte(CP_SJIS,0,p,2,szChar,3,NULL,NULL);
		wChar=((WORD)(BYTE)szChar[0]<<8)|(BYTE)szChar[1];
		if (szChar[2]!='\0')
			wNextChar=((WORD)(BYTE)szChar[2]<<8)|(BYTE)szChar[3];
		else
			wNextChar=0;
#endif
		pszPrevLetter=p;
		pszPrevAlpha=q;
		p+=KANA_LENGTH;
		switch (wChar) {
		case 0x829F:	/* '' */
			*q++=LaKey==KEY_LA?'L':'X';
			*q++='A';
			break;
		case 0x82A1:	/* '' */
			*q++=LiKey==KEY_LI?'L':'X';
			*q++='I';
			break;
		case 0x82A3:	/* '' */
			*q++=LuKey==KEY_LU?'L':'X';
			*q++='U';
			break;
		case 0x82A5:	/* '' */
			*q++=LeKey==KEY_LE?'L':'X';
			*q++='E';
			break;
		case 0x82A7:	/* '' */
			*q++=LoKey==KEY_LO?'L':'X';
			*q++='O';
			break;
		case 0x82A0:	/* '' */
		case 0x82A6:	/* '' */
		case 0x82A8:	/* '' */
			*q++=pszVowel[(wChar-0x82A0)/2];
			break;
		case 0x82A2:	/* '' */
			switch (wNextChar) {
			case 0x82A5:	/* '' */
				*q++='Y';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='I';
			}
			break;
		case 0x82A4:	/* '' */
			switch (wNextChar) {
			case 0x82A1:	/* '' */
				*q++='W';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='W';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='U';
			}
			break;
		case 0x82A9:	/* '' */
		case 0x82AD:	/* '' */
		case 0x82AF:	/* '' */
		case 0x82B1:	/* '' */
			*q++='K';
			*q++=pszVowel[(wChar-0x82A9)/2];
			break;
		case 0x82AB:	/* '' */
			*q++='K';
			switch (wNextChar) {
			case 0x82E1:	/* '' */
			case 0x82E3:	/* '' */
			case 0x82E5:	/* '' */
				*q++='Y';
				*q++=pszVowel[wNextChar-0x82E1];
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='Y';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='I';
			}
			break;
		case 0x82AA:	/* '' */
		case 0x82AE:	/* '' */
		case 0x82B0:	/* '' */
		case 0x82B2:	/* '' */
			*q++='G';
			*q++=pszVowel[(wChar-0x82AA)/2];
			break;
		case 0x82AC:	/* '' */
			*q++='G';
			switch (wNextChar) {
			case 0x82E1:	/* '' */
			case 0x82E3:	/* '' */
			case 0x82E5:	/* '' */
				*q++='Y';
				*q++=pszVowel[wNextChar-0x82E1];
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='Y';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='I';
			}
			break;
		case 0x82B3:	/* '' */
		case 0x82B7:	/* '' */
		case 0x82B9:	/* '' */
		case 0x82BB:	/* '' */
			*q++='S';
			*q++=pszVowel[(wChar-0x82B3)/2];
			break;
		case 0x82B5:	/* '' */
			*q++='S';
			switch (wNextChar) {
			case 0x82E1:	/* '' */
				*q++=SyaKey==KEY_SYA?'Y':'H';
				*q++='A';
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82E3:	/* '' */
				*q++=SyuKey==KEY_SYU?'Y':'H';
				*q++='U';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++=SyeKey==KEY_SYE?'Y':'H';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			case 0x82E5:	/* '' */
				*q++=SyoKey==KEY_SYO?'Y':'H';
				*q++='O';
				p+=KANA_LENGTH;
				break;
			default:
				if (SiKey==KEY_SHI)
					*q++='H';
				*q++='I';
			}
			break;
		case 0x82B4:	/* '' */
		case 0x82B8:	/* '' */
		case 0x82BA:	/* '' */
		case 0x82BC:	/* '' */
			*q++='Z';
			*q++=pszVowel[(wChar-0x82B4)/2];
			break;
		case 0x82B6:	/* '' */
			switch (wNextChar) {
			case 0x82E1:	/* '' */
				if (JyaKey==KEY_JYA) {
					*q++='J';
					*q++='Y';
				} else if (JyaKey==KEY_ZYA) {
					*q++='Z';
					*q++='Y';
				} else
					*q++='J';
				*q++='A';
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++=JyiKey==KEY_JYI?'J':'Z';
				*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82E3:	/* '' */
				if (JyuKey==KEY_JYU) {
					*q++='J';
					*q++='Y';
				} else if (JyuKey==KEY_ZYU) {
					*q++='Z';
					*q++='Y';
				} else
					*q++='J';
				*q++='U';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				if (JyeKey==KEY_JYE) {
					*q++='J';
					*q++='Y';
				} else if (JyeKey==KEY_ZYE) {
					*q++='Z';
					*q++='Y';
				} else
					*q++='J';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			case 0x82E5:	/* '' */
				*q++=JyoKey==KEY_JYO?'J':'Z';
				*q++='Y';
				*q++='O';
				p+=KANA_LENGTH;
				break;
			default:
				*q++=ZiKey==KEY_ZI?'Z':'J';
				*q++='I';
			}
			break;
		case 0x82BD:	/* '' */
			*q++='T';
			*q++='A';
			break;
		case 0x82BF:	/* '' */
			switch (wNextChar) {
			case 0x82E1:	/* '' */
				if (TyaKey==KEY_TYA) {
					*q++='T';
					*q++='Y';
				} else if (TyaKey==KEY_CYA) {
					*q++='C';
					*q++='Y';
				} else {
					*q++='C';
					*q++='H';
				}
				*q++='A';
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++=TyiKey==KEY_TYI?'T':'C';
				*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82E3:	/* '' */
				if (TyuKey==KEY_TYU) {
					*q++='T';
					*q++='Y';
				}else if (TyuKey==KEY_CYU) {
					*q++='C';
					*q++='Y';
				}else{
					*q++='T';
					*q++='H';
				}
				*q++='U';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				if (TyeKey==KEY_TYE) {
					*q++='T';
					*q++='Y';
				} else if (TyeKey==KEY_CYE) {
					*q++='C';
					*q++='Y';
				} else {
					*q++='T';
					*q++='H';
				}
				*q++='E';
				p+=KANA_LENGTH;
				break;
			case 0x82E5:	/* '' */
				if (TyoKey==KEY_TYO) {
					*q++='T';
					*q++='Y';
				} else if (TyoKey==KEY_CYO) {
					*q++='C';
					*q++='Y';
				} else {
					*q++='T';
					*q++='H';
				}
				*q++='O';
				p+=KANA_LENGTH;
				break;
			default:
				if (TiKey==KEY_TI) {
					*q++='T';
				} else {
					*q++='C';
					*q++='H';
				}
				*q++='I';
			}
			break;
		case 0x82C1:	/* '' */
			switch (wNextChar) {
			case 0x82C1:	/* '' */
				*q++=LtuKey==KEY_LTU?'L':'X';
			case 0:
			case 0x82A0:	/* '' */
			case 0x82A2:	/* '' */
			case 0x82A4:	/* '' */
			case 0x82A6:	/* '' */
			case 0x82A8:	/* '' */
				*q++=LtuKey==KEY_LTU?'L':'X';
				*q++='T';
				*q++='U';
				break;
			default:
				q++;
				fLtuMode=TRUE;
				continue;
			}
			break;
		case 0x82C2:	/* '' */
			*q++='T';
			if (TuKey==KEY_TSU)
				*q++='S';
			*q++='U';
			break;
		case 0x82C4:	/* '' */
			*q++='T';
			switch (wNextChar) {
			case 0x82E1:	/* '' */
			case 0x82E3:	/* '' */
			case 0x82E5:	/* '' */
				*q++='H';
				*q++=pszVowel[wNextChar-0x82E1];
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='H';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='H';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='E';
			}
			break;
		case 0x82C6:	/* '' */
			*q++='T';
			*q++='O';
			break;
		case 0x82BE:	/* '' */
			*q++='D';
			*q++='A';
			break;
		case 0x82C0:	/* '' */
			*q++='D';
			switch (wNextChar) {
			case 0x82E1:	/* '' */
			case 0x82E3:	/* '' */
			case 0x82E5:	/* '' */
				*q++='Y';
				*q++=pszVowel[wNextChar-0x82E1];
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='Y';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='I';
			}
			break;
		case 0x82C3:	/* '' */
			*q++='D';
			*q++='U';
			break;
		case 0x82C5:	/* '' */
			*q++='D';
			switch (wNextChar) {
			case 0x82E1:	/* '' */
			case 0x82E3:	/* '' */
			case 0x82E5:	/* '' */
				*q++='H';
				*q++=pszVowel[wNextChar-0x82E1];
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='H';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='H';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='E';
			}
			break;
		case 0x82C7:	/* '' */
			*q++='D';
			*q++='O';
			break;
		case 0x82C8:	/* '' */
		case 0x82CA:	/* '' */
		case 0x82CB:	/* '' */
		case 0x82CC:	/* '' */
			*q++='N';
			*q++=pszVowel[wChar-0x82C8];
			break;
		case 0x82C9:	/* '' */
			*q++='N';
			switch (wNextChar) {
			case 0x82E1:	/* '' */
			case 0x82E3:	/* '' */
			case 0x82E5:	/* '' */
				*q++='Y';
				*q++=pszVowel[wNextChar-0x82E1];
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='Y';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='I';
			}
			break;
		case 0x82CD:	/* '' */
		case 0x82D6:	/* '' */
		case 0x82D9:	/* '' */
			*q++='H';
			*q++=pszVowel[(wChar-0x82CD)/3];
			break;
		case 0x82D0:	/* '' */
			*q++='H';
			switch (wNextChar) {
			case 0x82E1:	/* '' */
			case 0x82E3:	/* '' */
			case 0x82E5:	/* '' */
				*q++='Y';
				*q++=pszVowel[wNextChar-0x82E1];
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='Y';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='I';
			}
			break;
		case 0x82D3:	/* '' */
			switch (wNextChar) {
			case 0x829F:	/* '' */
			case 0x82A7:	/* '' */
				*q++='F';
				*q++=pszVowel[(wNextChar-0x829F)/2];
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='F';
				if (FiKey==KEY_FYI)
					*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='F';
				if (FeKey==KEY_FYE)
					*q++='Y';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			case 0x82E1:	/* '' */
			case 0x82E3:	/* '' */
			case 0x82E5:	/* '' */
				*q++='F';
				*q++='Y';
				*q++=pszVowel[wNextChar-0x82E1];
				p+=KANA_LENGTH;
				break;
			default:
				*q++=HuKey==KEY_HU?'H':'F';
				*q++='U';
			}
			break;
		case 0x82CE:	/* '' */
		case 0x82D4:	/* '' */
		case 0x82D7:	/* '' */
		case 0x82DA:	/* '' */
			*q++='B';
			*q++=pszVowel[(wChar-0x82CE)/3];
			break;
		case 0x82D1:	/* '' */
			*q++='B';
			switch (wNextChar) {
			case 0x82E1:	/* '' */
			case 0x82E3:	/* '' */
			case 0x82E5:	/* '' */
				*q++='Y';
				*q++=pszVowel[wNextChar-0x82E1];
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='Y';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='I';
			}
			break;
		case 0x82CF:	/* '' */
		case 0x82D5:	/* '' */
		case 0x82D8:	/* '' */
		case 0x82DB:	/* '' */
			*q++='P';
			*q++=pszVowel[(wChar-0x82CF)/3];
			break;
		case 0x82D2:	/* '' */
			*q++='P';
			switch (wNextChar) {
			case 0x82E1:	/* '' */
			case 0x82E3:	/* '' */
			case 0x82E5:	/* '' */
				*q++='Y';
				*q++=pszVowel[wNextChar-0x82E1];
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='Y';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='I';
			}
			break;
		case 0x82DC:	/* '' */
		case 0x82DE:	/* '' */
		case 0x82DF:	/* '' */
		case 0x82E0:	/* '' */
			*q++='M';
			*q++=pszVowel[wChar-0x82DC];
			break;
		case 0x82DD:	/* '' */
			*q++='M';
			switch (wNextChar) {
			case 0x82E1:	/* '' */
			case 0x82E3:	/* '' */
			case 0x82E5:	/* '' */
				*q++='Y';
				*q++=pszVowel[wNextChar-0x82E1];
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='Y';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='I';
			}
			break;
		case 0x82E1:	/* '' */
			*q++=LyaKey==KEY_LYA?'L':'X';
			*q++='Y';
			*q++='A';
			break;
		case 0x82E3:	/* '' */
			*q++=LyuKey==KEY_LYU?'L':'X';
			*q++='Y';
			*q++='U';
			break;
		case 0x82E5:	/* '' */
			*q++=LyoKey==KEY_LYO?'L':'X';
			*q++='Y';
			*q++='O';
			break;
		case 0x82E2:	/* '' */
		case 0x82E4:	/* '' */
		case 0x82E6:	/* '' */
			*q++='Y';
			*q++=pszVowel[wChar-0x82E2];
			break;
		case 0x82E7:	/* '' */
		case 0x82E9:	/* '' */
		case 0x82EA:	/* '' */
		case 0x82EB:	/* '' */
			*q++='R';
			*q++=pszVowel[wChar-0x82E7];
			break;
		case 0x82E8:	/* '' */
			*q++='R';
			switch (wNextChar) {
			case 0x82E1:	/* '' */
			case 0x82E3:	/* '' */
			case 0x82E5:	/* '' */
				*q++='Y';
				*q++=pszVowel[wNextChar-0x82E1];
				p+=KANA_LENGTH;
				break;
			case 0x82A1:	/* '' */
				*q++='Y';
				*q++='I';
				p+=KANA_LENGTH;
				break;
			case 0x82A5:	/* '' */
				*q++='Y';
				*q++='E';
				p+=KANA_LENGTH;
				break;
			default:
				*q++='I';
			}
			break;
		case 0x82ED:	/* '' */
			*q++='W';
			*q++='A';
			break;
		case 0x82F0:	/* '' */
			*q++='W';
			*q++='O';
			break;
		case 0x82F1:	/* '' */
			*q++='N';
			switch (wNextChar) {
			case 0:
			case 0x82A0:	/* '' */
			case 0x82A2:	/* '' */
			case 0x82A4:	/* '' */
			case 0x82A6:	/* '' */
			case 0x82A8:	/* '' */
			case 0x82C8:	/* '' */
			case 0x82C9:	/* '' */
			case 0x82CA:	/* '' */
			case 0x82CB:	/* '' */
			case 0x82CC:	/* '' */
				*q++='N';
			}
			break;
		case 0x8394:	/* '' */
			*q++='V';
			*q++='U';
			break;
		case 0x815B:	/* '[' */
			*q++='-';
			break;
		default:
			{
				TCHAR szText[64];

				wsprintf(szText,TEXT("ȕ %04X"),wChar);
				MessageBox(hwndMain,szText,NULL,MB_OK | MB_ICONSTOP);
			}
			*q='\0';
			return;
		}
		if (fLtuMode) {
			pszPrevAlpha--;
			pszPrevAlpha[0]=pszPrevAlpha[1];
			pszPrevLetter-=KANA_LENGTH;
			fLtuMode=FALSE;
		}
		if (q-pszPrevAlpha>1) {
			for (j=0;j<(q-pszPrevAlpha)-1;j++)
				pnOffset[i++]=0;
		}
		pnOffset[i++]=p-pszPrevLetter;
	}
	*q='\0';
}


static void HighlightLetter(BOOL fHighlight,BOOL fRedraw)
{
	int i,j;
	int x;

	for (i=nCurAlphaLetter;nNextLetterOffset[i]==0;i++);
	x=nWordLeft+nCurLetter*(nFontSize/2);
	for (j=0;j<nNextLetterOffset[i];j+=KANA_LENGTH) {
		DIB_DrawText(pdibWindow,x,nWordTop,&pszCurWord[nCurLetter+j],
			KANA_LENGTH,hfontText,fHighlight?crHighlightTextColor:crTextColor);
		x+=nFontSize;
	}
	if (fRedraw)
		Redraw(nWordLeft+nCurLetter*(nFontSize/2),nWordTop,
							nNextLetterOffset[i]*(nFontSize/2),nFontSize,TRUE);
}


static void FadeLetter(int nOpacity,BOOL fRedraw)
{
	int r,g,b;
	int i,j;
	int x;

	r=(GetRValue(crTextColor)*nOpacity+
							GetRValue(crBackgroundColor)*(256-nOpacity))>>8;
	g=(GetGValue(crTextColor)*nOpacity+
							GetGValue(crBackgroundColor)*(256-nOpacity))>>8;
	b=(GetBValue(crTextColor)*nOpacity+
							GetBValue(crBackgroundColor)*(256-nOpacity))>>8;
	for (i=nCurAlphaLetter;nNextLetterOffset[i]==0;i++);
	x=nWordLeft+nCurLetter*(nFontSize/2);
	for (j=0;j<nNextLetterOffset[i];j+=KANA_LENGTH) {
		DIB_DrawText(pdibWindow,x,nWordTop,&pszCurWord[nCurLetter+j],
											KANA_LENGTH,hfontText,RGB(r,g,b));
		x+=nFontSize;
	}
	if (fRedraw)
		Redraw(nWordLeft+nCurLetter*(nFontSize/2),nWordTop,
							nNextLetterOffset[i]*(nFontSize/2),nFontSize,TRUE);
}


static void HighlightAlphaLetter(BOOL fHighlight,BOOL fRedraw)
{
	DIB_DrawText(pdibWindow,nAlphaLeft+nFontSize/2*nCurAlphaLetter,nAlphaTop,
								&szCurWordAlpha[nCurAlphaLetter],1,hfontText,
								fHighlight?crHighlightTextColor:crTextColor);
	if (fRedraw)
		Redraw(nAlphaLeft+nFontSize/2*nCurAlphaLetter,nAlphaTop,
												nFontSize/2,nFontSize,TRUE);
}


static void FadeAlphaLetter(int nOpacity,BOOL fRedraw)
{
	int r,g,b;

	r=(GetRValue(crTextColor)*nOpacity+
							GetRValue(crBackgroundColor)*(256-nOpacity))>>8;
	g=(GetGValue(crTextColor)*nOpacity+
							GetGValue(crBackgroundColor)*(256-nOpacity))>>8;
	b=(GetBValue(crTextColor)*nOpacity+
							GetBValue(crBackgroundColor)*(256-nOpacity))>>8;
	DIB_DrawText(pdibWindow,nAlphaLeft+nFontSize/2*nCurAlphaLetter,nAlphaTop,
					&szCurWordAlpha[nCurAlphaLetter],1,hfontText,RGB(r,g,b));
	if (fRedraw)
		Redraw(nAlphaLeft+nFontSize/2*nCurAlphaLetter,nAlphaTop,
												nFontSize/2,nFontSize,TRUE);
}


static void NextWord(LPCTSTR pszWord,BOOL fRedraw)
{
	LPCTSTR p;
	int x;
	int nLength;

	pszCurWord=pszWord;
	GetWordAlpha(pszCurWord,szCurWordAlpha,nNextLetterOffset);
	nCurLetter=0;
	nCurAlphaLetter=0;
	DIB_FillRect(pdibWindow,0,nAlphaTop,MAIN_WINDOW_WIDTH,nFontSize,
										crBackgroundColor,DIB_OPACITY_OPAQUE);
	DIB_FillRect(pdibWindow,0,nWordTop,MAIN_WINDOW_WIDTH,nFontSize,
										crBackgroundColor,DIB_OPACITY_OPAQUE);
	nLength=lstrlen(pszCurWord);
	nWordLeft=(MAIN_WINDOW_WIDTH-nFontSize/2*nLength)/2;
	x=nWordLeft;
	p=pszCurWord;
	while (*p!='\0') {
		DIB_DrawText(pdibWindow,x,nWordTop,p,KANA_LENGTH,hfontText,
																crTextColor);
		p+=KANA_LENGTH;
		x+=nFontSize;
	}
	nLength=lstrlen(szCurWordAlpha);
	nAlphaLeft=(MAIN_WINDOW_WIDTH-nFontSize/2*nLength)/2;
	x=nAlphaLeft;
	p=szCurWordAlpha;
	while (*p!='\0') {
		DIB_DrawText(pdibWindow,x,nAlphaTop,p,1,hfontText,crTextColor);
		p++;
		x+=nFontSize/2;
	}
	if (fRedraw) {
		Redraw(0,nWordTop,MAIN_WINDOW_WIDTH,nFontSize,TRUE);
		Redraw(0,nAlphaTop,MAIN_WINDOW_WIDTH,nFontSize,TRUE);
	}
	HighlightLetter(TRUE,fRedraw);
	HighlightAlphaLetter(TRUE,fRedraw);
	if (fShowKeyboard) {
		HighlightKeyboard(szCurWordAlpha[0],TRUE,fRedraw);
		HighlightHand(GetFinger(szCurWordAlpha[0]),TRUE,fRedraw);
	}
}


static LPCTSTR GetLessonLetter(LPCTSTR pszPrevLetter)
{
	static const LPCTSTR pszLetterList[] = {
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T("Ă"),	_T("Ă"),	_T("Ă"),	_T("Ă"),	_T("Ă"),
		_T("ł"),	_T("ł"),	_T("ł"),	_T("ł"),	_T("ł"),
		_T("ɂ"),	_T("ɂ"),	_T("ɂ"),	_T("ɂ"),	_T("ɂ"),
		_T("Ђ"),	_T("Ђ"),	_T("Ђ"),	_T("Ђ"),	_T("Ђ"),
		_T("т"),	_T("т"),	_T("т"),	_T("т"),	_T("т"),
		_T("҂"),	_T("҂"),	_T("҂"),	_T("҂"),	_T("҂"),
		_T("ӂ"),	_T("ӂ"),	_T("ӂ"),	_T("ӂ"),
		_T("ӂ"),	_T("ӂ"),	_T("ӂ"),
		_T("݂"),	_T("݂"),	_T("݂"),	_T("݂"),	_T("݂"),
		_T(""),	_T("股"),	_T(""),	_T("肥"),	_T(""),
		_T(""),	_T(""),	_T(""),	_T(""),	_T(""),
		_T(""),	_T(""),	_T(""),
		_T("")
	};
	LPCTSTR pszLetter;

	do {
		pszLetter=pszLetterList[Random(sizeof(pszLetterList)/sizeof(LPCTSTR))];
	} while (pszLetter==pszPrevLetter);
	return pszLetter;
}


static LPCTSTR GetLessonWord(LPCTSTR pszPrevWord)
{
	LPCTSTR pszWord;

	do {
		pszWord=ppszLessonWordList[Random(nNumLessonWords)];
	} while (pszWord==pszPrevWord);
	return pszWord;
}


static void StartLesson(int nLesson)
{
	LPCTSTR pszWord;
	HMENU hmenu;

	switch (nLesson) {
	case CM_LESSON_A:
		pszWord=TEXT("");	break;
	case CM_LESSON_KA:
		pszWord=TEXT("");	break;
	case CM_LESSON_SA:
		pszWord=TEXT("");	break;
	case CM_LESSON_TA:
		pszWord=TEXT("Ă");	break;
	case CM_LESSON_NA:
		pszWord=TEXT("Ȃɂʂ˂");	break;
	case CM_LESSON_HA:
		pszWord=TEXT("͂Ђӂւ");	break;
	case CM_LESSON_MA:
		pszWord=TEXT("܂݂ނ߂");	break;
	case CM_LESSON_YA:
		pszWord=TEXT("");		break;
	case CM_LESSON_RA:
		pszWord=TEXT("");	break;
	case CM_LESSON_WA:
		pszWord=TEXT("");		break;

	case CM_LESSON_GA:
		pszWord=TEXT("");	break;
	case CM_LESSON_ZA:
		pszWord=TEXT("");	break;
	case CM_LESSON_DA:
		pszWord=TEXT("Âł");	break;
	case CM_LESSON_BA:
		pszWord=TEXT("΂тԂׂ");	break;
	case CM_LESSON_PA:
		pszWord=TEXT("ς҂Ղ؂");	break;
	case CM_LESSON_VU:
		pszWord=TEXT("");			break;

	case CM_LESSON_KYA:
		pszWord=TEXT("Ⴋカ");	break;
	case CM_LESSON_GYA:
		pszWord=TEXT("Ⴌガ");	break;
	case CM_LESSON_SYA:
		pszWord=TEXT("Ⴕサ");	break;
	case CM_LESSON_JYA:
		pszWord=TEXT("Ⴖザ");	break;
	case CM_LESSON_TYA:
		pszWord=TEXT("Ⴟタ");	break;
	case CM_LESSON_DYA:
		pszWord=TEXT("");	break;
	case CM_LESSON_THA:
		pszWord=TEXT("ĂĂĂĂĂ");	break;
	case CM_LESSON_DHA:
		pszWord=TEXT("łłłłł");	break;
	case CM_LESSON_NYA:
		pszWord=TEXT("ɂɂɂɂɂ");	break;
	case CM_LESSON_HYA:
		pszWord=TEXT("ЂЂЂЂЂ");	break;
	case CM_LESSON_BYA:
		pszWord=TEXT("ттттт");	break;
	case CM_LESSON_PYA:
		pszWord=TEXT("҂҂҂҂҂");	break;
	case CM_LESSON_FA:
		pszWord=TEXT("ӂӂӂӂ");		break;
	case CM_LESSON_FYA:
		pszWord=TEXT("ӂӂӂ");			break;
	case CM_LESSON_MYA:
		pszWord=TEXT("݂݂݂݂݂");	break;
	case CM_LESSON_RYA:
		pszWord=TEXT("股肥");	break;

	case CM_LESSON_LA:
		pszWord=TEXT("");	break;
	case CM_LESSON_LYA:
		pszWord=TEXT("");		break;
	case CM_LESSON_LTU:
		pszWord=TEXT("");			break;

	case CM_LESSON_LETTER:
		pszWord=GetLessonLetter(NULL);	break;
	case CM_LESSON_WORD:
		pszWord=GetLessonWord(NULL);	break;
	}
	DIB_FillRect(pdibWindow,0,0,MAIN_WINDOW_WIDTH,MAIN_WINDOW_HEIGHT,
										crBackgroundColor,DIB_OPACITY_OPAQUE);
	if (!fShowKeyboard) {
		nWordTop=(MAIN_WINDOW_HEIGHT-nFontSize*2)/2;
		nAlphaTop=MAIN_WINDOW_HEIGHT/2;
	} else {
		nWordTop=(MAIN_WINDOW_HEIGHT/2-nFontSize*2)/2;
		nAlphaTop=MAIN_WINDOW_HEIGHT/4;
		DrawKeyboard(FALSE);
		DrawHand(FALSE);
	}
	NextWord(pszWord,FALSE);
	InvalidateRect(hwndMain,NULL,TRUE);
	UpdateWindow(hwndMain);
	hmenu=GetMenu(hwndMain);
	if (!fPlaying) {
		EnableMenuItem(hmenu,CM_TITLE,MF_BYCOMMAND | MFS_ENABLED);
		EnableMenuItem(hmenu,CM_SHOWKEYBOARD,MF_BYCOMMAND | MFS_GRAYED);
		EnableMenuItem(hmenu,CM_OPTIONS,MF_BYCOMMAND | MFS_GRAYED);
		fPlaying=TRUE;
	} else
		CheckMenuItem(hmenu,nCurLesson,MF_BYCOMMAND | MFS_UNCHECKED);
	nCurLesson=nLesson;
	CheckMenuItem(hmenu,nCurLesson,MF_BYCOMMAND | MFS_CHECKED);
}


static BOOL ChooseColorDialog(HWND hwndOwner,COLORREF *pcrResult)
{
	static COLORREF crCustomColors[16] = {
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF)
	};
	CHOOSECOLOR cc;

	cc.lStructSize=sizeof(CHOOSECOLOR);
	cc.hwndOwner=hwndOwner;
	cc.hInstance=NULL;
	cc.rgbResult=*pcrResult;
	cc.lpCustColors=crCustomColors;
	cc.Flags=CC_RGBINIT;
	if (!ChooseColor(&cc))
		return FALSE;
	*pcrResult=cc.rgbResult;
	return TRUE;
}


BOOL ChooseFontDialog(HWND hwndOwner,LOGFONT *plf)
{
	CHOOSEFONT cf;

	cf.lStructSize=sizeof(CHOOSEFONT);
	cf.hwndOwner=hwndOwner;
	cf.lpLogFont=plf;
	cf.Flags=CF_FORCEFONTEXIST | CF_FIXEDPITCHONLY | CF_INITTOLOGFONTSTRUCT |
																CF_SCREENFONTS;
	if (!ChooseFont(&cf))
		return FALSE;
	return TRUE;
}


static void SetFontStatus(HWND hDlg,int nID,const LOGFONT *plf)
{
	HDC hdc;
	HFONT hfont,hfontOld;
	TEXTMETRIC tm;
	TCHAR szText[LF_FACESIZE+16];

	hdc=GetDC(hwndMain);
	if (hdc==NULL)
		return;
	hfont=CreateFontIndirect(plf);
	if (hfont==NULL) {
		ReleaseDC(hwndMain,hdc);
		return;
	}
	hfontOld=(HFONT)SelectObject(hdc,hfont);
	GetTextMetrics(hdc,&tm);
	wsprintf(szText,TEXT("%s / %d"),plf->lfFaceName,
		(tm.tmHeight-tm.tmInternalLeading)*72/GetDeviceCaps(hdc,LOGPIXELSY));
	SetDlgItemText(hDlg,nID,szText);
	SelectObject(hdc,hfontOld);
	DeleteObject(hfont);
	ReleaseDC(hwndMain,hdc);
}


BOOL CALLBACK ColorOptionsDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	static struct {
		COLORREF crTextColor;
		COLORREF crHighlightTextColor;
		COLORREF crBackgroundColor;
		LOGFONT lfTextFont;
		HFONT hfontText;
		int nFontSize;
		BOOL fFontChanged;
	} Info;

	switch (uMsg) {
	case WM_INITDIALOG:
		Info.crTextColor=crTextColor;
		Info.crHighlightTextColor=crHighlightTextColor;
		Info.crBackgroundColor=crBackgroundColor;
		Info.lfTextFont=lfTextFont;
		Info.hfontText=hfontText;
		Info.nFontSize=nFontSize;
		Info.fFontChanged=FALSE;
		SetFontStatus(hDlg,IDC_OPT_CURFONT,&lfTextFont);
		return TRUE;

	case WM_DRAWITEM:
		{
			const DRAWITEMSTRUCT *pdis=(DRAWITEMSTRUCT*)lParam;
			HBRUSH hbr;

			if (pdis->CtlID==IDC_OPT_FONTPREVIEW) {
				HFONT hfontOld;
				int nOldBkMode;
				COLORREF crOldTextColor;
				int nLength,x,y;
				SIZE sz;

				hbr=CreateSolidBrush(Info.crBackgroundColor);
				FillRect(pdis->hDC,&pdis->rcItem,hbr);
				DeleteObject(hbr);
				hfontOld=SelectObject(pdis->hDC,Info.hfontText);
				nOldBkMode=SetBkMode(pdis->hDC,TRANSPARENT);
				nLength=lstrlen(Info.lfTextFont.lfFaceName);
				GetTextExtentPoint32(pdis->hDC,Info.lfTextFont.lfFaceName,
																nLength,&sz);
				x=(pdis->rcItem.right-sz.cx)/2;
				if (x<0)
					x=0;
				y=(pdis->rcItem.bottom-sz.cy)/2;
				if (y<0)
					y=0;
				crOldTextColor=SetTextColor(pdis->hDC,Info.crTextColor);
				TextOut(pdis->hDC,x,y,Info.lfTextFont.lfFaceName,nLength);
				SetTextColor(pdis->hDC,Info.crHighlightTextColor);
				TextOut(pdis->hDC,x,y,Info.lfTextFont.lfFaceName,
#ifndef UNICODE
					IsDBCSLeadByteEx(CP_ACP,Info.lfTextFont.lfFaceName[0])?2:1
#else
					1
#endif
				);
				SelectObject(pdis->hDC,hfontOld);
				SetTextColor(pdis->hDC,crOldTextColor);
				SetBkMode(pdis->hDC,nOldBkMode);
			} else {
				COLORREF crColor;

				switch (pdis->CtlID) {
				case IDC_OPT_TEXTCOLORSAMPLE:
					crColor=Info.crTextColor;			break;
				case IDC_OPT_HLTEXTCOLORSAMPLE:
					crColor=Info.crHighlightTextColor;	break;
				case IDC_OPT_BGCOLORSAMPLE:
					crColor=Info.crBackgroundColor;		break;
				}
				hbr=CreateSolidBrush(crColor);
				FillRect(pdis->hDC,&pdis->rcItem,hbr);
				DeleteObject(hbr);
			}
		}
		return TRUE;

	case WM_NOTIFY:
		switch (((NMHDR*)lParam)->code) {
		case PSN_APPLY:
			crTextColor=Info.crTextColor;
			crHighlightTextColor=Info.crHighlightTextColor;
			crBackgroundColor=Info.crBackgroundColor;
			if (Info.fFontChanged) {
				DeleteObject(hfontText);
				hfontText=Info.hfontText;
				lfTextFont=Info.lfTextFont;
				nFontSize=Info.nFontSize;
			}
			break;
		case PSN_RESET:
			if (Info.fFontChanged)
				DeleteObject(Info.hfontText);
			break;
		}
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_OPT_TEXTCOLORSAMPLE:
			if (HIWORD(wParam)!=STN_CLICKED)
				return TRUE;
		case IDC_OPT_TEXTCOLOR:
			if (ChooseColorDialog(hDlg,&Info.crTextColor)) {
				InvalidateRect(GetDlgItem(hDlg,IDC_OPT_TEXTCOLORSAMPLE),NULL,
																		TRUE);
				InvalidateRect(GetDlgItem(hDlg,IDC_OPT_FONTPREVIEW),NULL,TRUE);
			}
			return TRUE;
		case IDC_OPT_HLTEXTCOLORSAMPLE:
			if (HIWORD(wParam)!=STN_CLICKED)
				return TRUE;
		case IDC_OPT_HLTEXTCOLOR:
			if (ChooseColorDialog(hDlg,&Info.crHighlightTextColor)) {
				InvalidateRect(GetDlgItem(hDlg,IDC_OPT_HLTEXTCOLORSAMPLE),NULL,
																		TRUE);
				InvalidateRect(GetDlgItem(hDlg,IDC_OPT_FONTPREVIEW),NULL,TRUE);
			}
			return TRUE;
		case IDC_OPT_BGCOLORSAMPLE:
			if (HIWORD(wParam)!=STN_CLICKED)
				return TRUE;
		case IDC_OPT_BGCOLOR:
			if (ChooseColorDialog(hDlg,&Info.crBackgroundColor)) {
				InvalidateRect(GetDlgItem(hDlg,IDC_OPT_BGCOLORSAMPLE),NULL,
																		TRUE);
				InvalidateRect(GetDlgItem(hDlg,IDC_OPT_FONTPREVIEW),NULL,TRUE);
			}
			return TRUE;
		case IDC_OPT_BROWSEFONT:
			{
				LOGFONT lf;
				HFONT hfont,hfontOld;
				HDC hdc;
				TEXTMETRIC tm;

				lf=Info.lfTextFont;
				if (!ChooseFontDialog(hDlg,&lf))
					return TRUE;
				hfont=CreateFontIndirect(&lf);
				if (hfont==NULL) {
					MessageBox(hDlg,TEXT("tHg쐬ł܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
					return TRUE;
				}
				hdc=GetDC(hwndMain);
				hfontOld=(HFONT)SelectObject(hdc,hfont);
				GetTextMetrics(hdc,&tm);
				SelectObject(hdc,hfontOld);
				ReleaseDC(hwndMain,hdc);
				if (!Info.fFontChanged)
					Info.fFontChanged=TRUE;
				else
					DeleteObject(Info.hfontText);
				Info.lfTextFont=lf;
				Info.hfontText=hfont;
				Info.nFontSize=tm.tmHeight;
				SetFontStatus(hDlg,IDC_OPT_CURFONT,&Info.lfTextFont);
				InvalidateRect(GetDlgItem(hDlg,IDC_OPT_FONTPREVIEW),NULL,TRUE);
			}
			return TRUE;
		}
		return TRUE;
	}
	return FALSE;
}


static void SetComboBoxList(HWND hDlg,int nID,LPCTSTR pszList)
{
	LPCTSTR p=pszList;

	while (*p!='\0') {
		SendDlgItemMessage(hDlg,nID,CB_ADDSTRING,0,(LPARAM)p);
		p+=lstrlen(p)+1;
	}
}


#ifdef __BORLANDC__
#pragma argsused
#endif
BOOL CALLBACK KeyOptionsDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		{
			static const LPCTSTR pmszList[] = {
				TEXT("SI\0SHI\0"),
				TEXT("TI\0CHI\0"),
				TEXT("TU\0TSU\0"),
				TEXT("HU\0FU\0"),
				TEXT("ZI\0JI\0"),
				TEXT("SYA\0SHA\0"),
				TEXT("SYU\0SHU\0"),
				TEXT("SYE\0SHE\0"),
				TEXT("SYO\0SHO\0"),
				TEXT("JYA\0ZYA\0JA\0"),
				TEXT("JYI\0ZYI\0"),
				TEXT("JYU\0ZYU\0JU\0"),
				TEXT("JYE\0ZYE\0JE\0"),
				TEXT("JYO\0ZYO\0JO\0"),
				TEXT("TYA\0CYA\0CHA\0"),
				TEXT("TYI\0CYI\0"),
				TEXT("TYU\0CYU\0THU\0"),
				TEXT("TYE\0CYE\0THE\0"),
				TEXT("TYO\0CYO\0THO\0"),
				TEXT("FI\0FYI\0"),
				TEXT("FE\0FYE\0"),
				TEXT("LA\0XA\0"),
				TEXT("LI\0XI\0"),
				TEXT("LU\0XU\0"),
				TEXT("LE\0XE\0"),
				TEXT("LO\0XO\0"),
				TEXT("LTU\0XTU\0"),
				TEXT("LYA\0XYA\0"),
				TEXT("LYU\0XYU\0"),
				TEXT("LYO\0XYO\0")
			};
			int i;

			for (i=IDC_OPT_SI;i<=IDC_OPT_LYO;i++)
				SetComboBoxList(hDlg,i,pmszList[i-IDC_OPT_SI]);
		}
		SendDlgItemMessage(hDlg,IDC_OPT_SI,CB_SETCURSEL,SiKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_TI,CB_SETCURSEL,TiKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_TU,CB_SETCURSEL,TuKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_HU,CB_SETCURSEL,HuKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_ZI,CB_SETCURSEL,ZiKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_SYA,CB_SETCURSEL,SyaKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_SYU,CB_SETCURSEL,SyuKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_SYE,CB_SETCURSEL,SyeKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_SYO,CB_SETCURSEL,SyoKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_JYA,CB_SETCURSEL,JyaKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_JYI,CB_SETCURSEL,JyiKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_JYU,CB_SETCURSEL,JyuKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_JYE,CB_SETCURSEL,JyeKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_JYO,CB_SETCURSEL,JyoKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_TYA,CB_SETCURSEL,TyaKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_TYI,CB_SETCURSEL,TyiKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_TYU,CB_SETCURSEL,TyuKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_TYE,CB_SETCURSEL,TyeKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_TYO,CB_SETCURSEL,TyoKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_FI,CB_SETCURSEL,FiKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_FE,CB_SETCURSEL,FeKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_LA,CB_SETCURSEL,LaKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_LI,CB_SETCURSEL,LiKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_LU,CB_SETCURSEL,LuKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_LE,CB_SETCURSEL,LeKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_LO,CB_SETCURSEL,LoKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_LTU,CB_SETCURSEL,LtuKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_LYA,CB_SETCURSEL,LyaKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_LYU,CB_SETCURSEL,LyuKey,0);
		SendDlgItemMessage(hDlg,IDC_OPT_LYO,CB_SETCURSEL,LyoKey,0);
		return TRUE;

	case WM_NOTIFY:
		switch (((NMHDR*)lParam)->code) {
		case PSN_APPLY:
			SiKey=SendDlgItemMessage(hDlg,IDC_OPT_SI,CB_GETCURSEL,0,0);
			TiKey=SendDlgItemMessage(hDlg,IDC_OPT_TI,CB_GETCURSEL,0,0);
			TuKey=SendDlgItemMessage(hDlg,IDC_OPT_TU,CB_GETCURSEL,0,0);
			HuKey=SendDlgItemMessage(hDlg,IDC_OPT_HU,CB_GETCURSEL,0,0);
			ZiKey=SendDlgItemMessage(hDlg,IDC_OPT_ZI,CB_GETCURSEL,0,0);
			SyaKey=SendDlgItemMessage(hDlg,IDC_OPT_SYA,CB_GETCURSEL,0,0);
			SyuKey=SendDlgItemMessage(hDlg,IDC_OPT_SYU,CB_GETCURSEL,0,0);
			SyeKey=SendDlgItemMessage(hDlg,IDC_OPT_SYE,CB_GETCURSEL,0,0);
			SyoKey=SendDlgItemMessage(hDlg,IDC_OPT_SYO,CB_GETCURSEL,0,0);
			JyaKey=SendDlgItemMessage(hDlg,IDC_OPT_JYA,CB_GETCURSEL,0,0);
			JyiKey=SendDlgItemMessage(hDlg,IDC_OPT_JYI,CB_GETCURSEL,0,0);
			JyuKey=SendDlgItemMessage(hDlg,IDC_OPT_JYU,CB_GETCURSEL,0,0);
			JyeKey=SendDlgItemMessage(hDlg,IDC_OPT_JYE,CB_GETCURSEL,0,0);
			JyoKey=SendDlgItemMessage(hDlg,IDC_OPT_JYO,CB_GETCURSEL,0,0);
			TyaKey=SendDlgItemMessage(hDlg,IDC_OPT_TYA,CB_GETCURSEL,0,0);
			TyiKey=SendDlgItemMessage(hDlg,IDC_OPT_TYI,CB_GETCURSEL,0,0);
			TyuKey=SendDlgItemMessage(hDlg,IDC_OPT_TYU,CB_GETCURSEL,0,0);
			TyeKey=SendDlgItemMessage(hDlg,IDC_OPT_TYE,CB_GETCURSEL,0,0);
			TyoKey=SendDlgItemMessage(hDlg,IDC_OPT_TYO,CB_GETCURSEL,0,0);
			FiKey=SendDlgItemMessage(hDlg,IDC_OPT_FI,CB_GETCURSEL,0,0);
			FeKey=SendDlgItemMessage(hDlg,IDC_OPT_FE,CB_GETCURSEL,0,0);
			LaKey=SendDlgItemMessage(hDlg,IDC_OPT_LA,CB_GETCURSEL,0,0);
			LiKey=SendDlgItemMessage(hDlg,IDC_OPT_LI,CB_GETCURSEL,0,0);
			LuKey=SendDlgItemMessage(hDlg,IDC_OPT_LU,CB_GETCURSEL,0,0);
			LeKey=SendDlgItemMessage(hDlg,IDC_OPT_LE,CB_GETCURSEL,0,0);
			LoKey=SendDlgItemMessage(hDlg,IDC_OPT_LO,CB_GETCURSEL,0,0);
			LtuKey=SendDlgItemMessage(hDlg,IDC_OPT_LTU,CB_GETCURSEL,0,0);
			LyaKey=SendDlgItemMessage(hDlg,IDC_OPT_LYA,CB_GETCURSEL,0,0);
			LyuKey=SendDlgItemMessage(hDlg,IDC_OPT_LYU,CB_GETCURSEL,0,0);
			LyoKey=SendDlgItemMessage(hDlg,IDC_OPT_LYO,CB_GETCURSEL,0,0);
			break;
		}
		break;
	}
	return FALSE;
}


#ifdef __BORLANDC__
#pragma argsused
#endif
BOOL CALLBACK AboutDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg,LOWORD(wParam));
		}
		return TRUE;
	}
	return FALSE;
}


LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_CREATE:
		if (!DIB_Create(&pdibWindow,MAIN_WINDOW_WIDTH,MAIN_WINDOW_HEIGHT,24)) {
			MessageBox(NULL,TEXT("ʗpDIB쐬ł܂B"),NULL,
														MB_OK | MB_ICONSTOP);
			return -1;
		}
		if (!DIB_Load(&pdibTitle,TEXT("title.bmp"))) {
			MessageBox(NULL,TEXT("^Cg摜(title.bmp)ǂݍ߂܂B"),
													NULL,MB_OK | MB_ICONSTOP);
			return -1;
		}
		DIB_Copy(pdibWindow,0,0,pdibTitle->nWidth,pdibTitle->nHeight,
											pdibTitle,0,0,256,DIB_COPY_NORMAL);
		hfontText=CreateFontIndirect(&lfTextFont);
		if (fShowKeyboard) {
			if (!DIB_Load(&pdibKeyboard,TEXT("keyboard.bmp"))
									|| !DIB_Load(&pdibHand,TEXT("hand.bmp"))) {
				MessageBox(NULL,TEXT("L[{[h̉摜ǂݍ߂܂B"),
													NULL,MB_OK | MB_ICONSTOP);
				return -1;
			}
		}
		return 0;

	case WM_PAINT:
		{
			PAINTSTRUCT ps;

			BeginPaint(hWnd,&ps);
			if (pdibWindow!=NULL && pdibWindow->hbm!=NULL) {
				HDC hdcMem;
				HBITMAP hbmOld;

				hdcMem=CreateCompatibleDC(ps.hdc);
				hbmOld=(HBITMAP)SelectObject(hdcMem,pdibWindow->hbm);
				BitBlt(ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ps.rcPaint.right,
					ps.rcPaint.bottom,hdcMem,ps.rcPaint.left,ps.rcPaint.top,
																	SRCCOPY);
				SelectObject(hdcMem,hbmOld);
				DeleteDC(hdcMem);
			} else
				FillRect(ps.hdc,&ps.rcPaint,GetStockObject(WHITE_BRUSH));
			EndPaint(hWnd,&ps);
		}
		return 0;

	case WM_CHAR:
		if (fPlaying) {
			TCHAR cChar=(TCHAR)wParam;

#ifndef UNICODE
			static BOOL fDBChar=FALSE;

			if (fDBChar) {
				fDBChar=FALSE;
				return 0;
			} else if (IsDBCSLeadByteEx(CP_ACP,cChar)) {
				fDBChar=TRUE;
				return 0;
			}
#endif
			if ((BYTE)cChar<0x20 || (BYTE)cChar>0x7E)
				return 0;
			CharUpper(&cChar);
			if (cChar==szCurWordAlpha[nCurAlphaLetter]) {
				FadeAlphaLetter(128,TRUE);
				if (nNextLetterOffset[nCurAlphaLetter]!=0)
					FadeLetter(128,TRUE);
				if (fShowKeyboard) {
					HighlightKeyboard(szCurWordAlpha[nCurAlphaLetter],FALSE,
																		TRUE);
					HighlightHand(GetFinger(szCurWordAlpha[nCurAlphaLetter]),
																FALSE,TRUE);
				}
				nCurAlphaLetter++;
				if (szCurWordAlpha[nCurAlphaLetter]!='\0') {
					if (nNextLetterOffset[nCurAlphaLetter-1]>0) {
						nCurLetter+=nNextLetterOffset[nCurAlphaLetter-1];
						HighlightLetter(TRUE,TRUE);
					}
					HighlightAlphaLetter(TRUE,TRUE);
					if (fShowKeyboard) {
						HighlightKeyboard(szCurWordAlpha[nCurAlphaLetter],TRUE,
																		TRUE);
						HighlightHand(
							GetFinger(szCurWordAlpha[nCurAlphaLetter]),TRUE,
																		TRUE);
					}
				} else {
					Sleep(200);
					switch (nCurLesson) {
					case CM_LESSON_LETTER:
						NextWord(GetLessonLetter(pszCurWord),TRUE);
						break;
					case CM_LESSON_WORD:
						NextWord(GetLessonWord(pszCurWord),TRUE);
						break;
					default:
						NextWord(pszCurWord,TRUE);
					}
				}
			} else {
				if (fShowKeyboard) {
					HighlightKeyboard(szCurWordAlpha[nCurAlphaLetter],FALSE,
																		TRUE);
					HighlightKeyboard(cChar,TRUE,TRUE);
				}
				HighlightAlphaLetter(FALSE,TRUE);
				Sleep(150);
				HighlightAlphaLetter(TRUE,TRUE);
				if (fShowKeyboard) {
					HighlightKeyboard(cChar,FALSE,TRUE);
					HighlightKeyboard(szCurWordAlpha[nCurAlphaLetter],TRUE,
																		TRUE);
				}
			}
		}
		return 0;

	case WM_KEYDOWN:
		if (wParam==VK_RETURN) {
			if (fPlaying) {
				int nNext;

				switch (nCurLesson) {
				case CM_LESSON_WA:
					nNext=CM_LESSON_GA;		break;
				case CM_LESSON_VU:
					nNext=CM_LESSON_KYA;	break;
				case CM_LESSON_RYA:
					nNext=CM_LESSON_LA;		break;
				case CM_LESSON_LTU:
					nNext=CM_LESSON_LETTER;	break;
				case CM_LESSON_LETTER:
					if (ppszLessonWordList!=NULL)
						nNext=CM_LESSON_WORD;
					else
						nNext=CM_TITLE;
					break;
				case CM_LESSON_WORD:
					nNext=CM_TITLE;			break;
				default:
					nNext=nCurLesson+1;
				}
				SendMessage(hWnd,WM_COMMAND,MAKEWPARAM(nNext,0),0);
			} else
				SendMessage(hWnd,WM_COMMAND,MAKEWPARAM(CM_LESSON_A,0),0);
		} else if (fPlaying && wParam==VK_ESCAPE)
			SendMessage(hWnd,WM_COMMAND,MAKEWPARAM(CM_TITLE,0),0);
		return 0;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case CM_TITLE:
			if (fPlaying) {
				HMENU hmenu;

				fPlaying=FALSE;
				hmenu=GetMenu(hwndMain);
				CheckMenuItem(hmenu,nCurLesson,MF_BYCOMMAND | MFS_UNCHECKED);
				nCurLesson=-1;
				EnableMenuItem(hmenu,CM_TITLE,MF_BYCOMMAND | MFS_GRAYED);
				EnableMenuItem(hmenu,CM_SHOWKEYBOARD,
												MF_BYCOMMAND | MFS_ENABLED);
				EnableMenuItem(hmenu,CM_OPTIONS,MF_BYCOMMAND | MFS_ENABLED);
				DIB_Copy(pdibWindow,0,0,pdibTitle->nWidth,pdibTitle->nHeight,
											pdibTitle,0,0,256,DIB_COPY_NORMAL);
				Redraw(0,0,MAIN_WINDOW_WIDTH,MAIN_WINDOW_HEIGHT,TRUE);
			}
			return 0;
		case CM_EXIT:
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		case CM_LESSON_A:
		case CM_LESSON_KA:
		case CM_LESSON_SA:
		case CM_LESSON_TA:
		case CM_LESSON_NA:
		case CM_LESSON_HA:
		case CM_LESSON_MA:
		case CM_LESSON_YA:
		case CM_LESSON_RA:
		case CM_LESSON_WA:

		case CM_LESSON_GA:
		case CM_LESSON_ZA:
		case CM_LESSON_DA:
		case CM_LESSON_BA:
		case CM_LESSON_PA:
		case CM_LESSON_VU:

		case CM_LESSON_KYA:
		case CM_LESSON_GYA:
		case CM_LESSON_SYA:
		case CM_LESSON_JYA:
		case CM_LESSON_TYA:
		case CM_LESSON_DYA:
		case CM_LESSON_THA:
		case CM_LESSON_DHA:
		case CM_LESSON_NYA:
		case CM_LESSON_HYA:
		case CM_LESSON_BYA:
		case CM_LESSON_PYA:
		case CM_LESSON_FA:
		case CM_LESSON_FYA:
		case CM_LESSON_MYA:
		case CM_LESSON_RYA:

		case CM_LESSON_LA:
		case CM_LESSON_LYA:
		case CM_LESSON_LTU:

		case CM_LESSON_LETTER:
			StartLesson(LOWORD(wParam));
			return 0;
		case CM_LESSON_WORD:
			if (ppszLessonWordList==NULL) {
				if (!LoadLessonWords(szLessonWordsFileName,&ppszLessonWordList,
															&nNumLessonWords))
					return 0;
			}
			StartLesson(CM_LESSON_WORD);
			return 0;
		case CM_SHOWKEYBOARD:
			if (!fShowKeyboard) {
				if (pdibKeyboard==NULL) {
					if (!DIB_Load(&pdibKeyboard,TEXT("keyboard.bmp"))) {
						MessageBox(hWnd,
							TEXT("L[{[h̉摜ǂݍ߂܂B"),NULL,
														MB_OK | MB_ICONSTOP);
						return 0;
					}
				}
				if (pdibHand==NULL) {
					if (!DIB_Load(&pdibHand,TEXT("hand.bmp"))) {
						MessageBox(hWnd,
									TEXT("̉摜ǂݍ߂܂B"),NULL,
														MB_OK | MB_ICONSTOP);
						return 0;
					}
				}
			}
			fShowKeyboard=!fShowKeyboard;
			CheckMenuItem(GetMenu(hwndMain),CM_SHOWKEYBOARD,MF_BYCOMMAND |
									(fShowKeyboard?MFS_CHECKED:MFS_UNCHECKED));
			return 0;
		case CM_OPTIONS:
			{
#ifdef NONAMELESSUNION
#define PS_UNION(ps,u) ps.u
#else
#define PS_UNION(ps,u) ps
#endif

				PROPSHEETPAGE psp[2];
				PROPSHEETHEADER psh;

				psp[0].dwSize=sizeof(PROPSHEETPAGE);
				psp[0].dwFlags=PSP_DEFAULT;
				psp[0].hInstance=hInst;
				PS_UNION(psp[0],u).pszTemplate=
											MAKEINTRESOURCE(IDD_OPTIONS_COLOR);
				psp[0].pfnDlgProc=ColorOptionsDlgProc;
				psp[1].dwSize=sizeof(PROPSHEETPAGE);
				psp[1].dwFlags=PSP_DEFAULT;
				psp[1].hInstance=hInst;
				PS_UNION(psp[1],u).pszTemplate=
											MAKEINTRESOURCE(IDD_OPTIONS_KEY);
				psp[1].pfnDlgProc=KeyOptionsDlgProc;
				psh.dwSize=sizeof(PROPSHEETHEADER);
				psh.dwFlags=PSH_NOAPPLYNOW | PSH_PROPSHEETPAGE;
				psh.hwndParent=hWnd;
				psh.hInstance=hInst;
				psh.pszCaption=TEXT("ݒ");
				psh.nPages=sizeof(psp)/sizeof(PROPSHEETPAGE);
				PS_UNION(psh,u2).nStartPage=0;
				PS_UNION(psh,u3).ppsp=psp;
				PropertySheet(&psh);
			}
			return 0;
		case CM_ABOUT:
			DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUT),hWnd,AboutDlgProc);
			return 0;
		}
		return 0;

	case WM_DESTROY:
		{
			WINDOWPLACEMENT wp;

			wp.length=sizeof(WINDOWPLACEMENT);
			if (GetWindowPlacement(hWnd,&wp)) {
				nMainWindowLeft=wp.rcNormalPosition.left;
				nMainWindowTop=wp.rcNormalPosition.top;
			}
			PostQuitMessage(0);
		}
		return 0;
	}
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}


#ifdef __BORLANDC__
#pragma argsused
#endif
int APIENTRY _tWinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
												LPTSTR pszCmdLine,int nCmdShow)
{
	WNDCLASS wc;
	TCHAR szIniFileName[MAX_PATH];
	RECT rcWnd,rcWork;
	HMENU hmenu;
	MSG msg;

	hInst=hInstance;

	wc.style=0;
	wc.lpfnWndProc=WndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=NULL;
	wc.lpszMenuName=NULL;
	wc.lpszClassName=MAIN_WINDOW_CLASS;
	if (!RegisterClass(&wc)) {
		MessageBox(NULL,TEXT("EBhENXo^ł܂B"),NULL,MB_OK);
		return FALSE;
	}

	srand((unsigned int)GetTickCount());

	lfTextFont.lfHeight=nFontSize;
	lfTextFont.lfWidth=0;
	lfTextFont.lfEscapement=0;
	lfTextFont.lfOrientation=0;
	lfTextFont.lfWeight=FW_NORMAL;
	lfTextFont.lfItalic=FALSE;
	lfTextFont.lfUnderline=FALSE;
	lfTextFont.lfStrikeOut=FALSE;
	lfTextFont.lfCharSet=SHIFTJIS_CHARSET;
	lfTextFont.lfOutPrecision=OUT_TT_PRECIS;
	lfTextFont.lfClipPrecision=CLIP_DEFAULT_PRECIS;
	lfTextFont.lfQuality=DRAFT_QUALITY;
	lfTextFont.lfPitchAndFamily=DEFAULT_PITCH | FF_DONTCARE;
	lstrcpy(lfTextFont.lfFaceName,TEXT("lr SVbN"));

	GetModuleFileName(hInst,szIniFileName,MAX_PATH);
	lstrcpy(GetFileNamePtr(szIniFileName),TEXT("romaji.ini"));
	if (FileExists(szIniFileName))
		LoadSettings(szIniFileName);

	rcWnd.left=0;
	rcWnd.top=0;
	rcWnd.right=MAIN_WINDOW_WIDTH;
	rcWnd.bottom=MAIN_WINDOW_HEIGHT;
	AdjustWindowRect(&rcWnd,
				WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,TRUE);
	OffsetRect(&rcWnd,-rcWnd.left,-rcWnd.top);
	SystemParametersInfo(SPI_GETWORKAREA,0,&rcWork,0);
	if (nMainWindowLeft==CW_USEDEFAULT) {
		nMainWindowLeft=rcWork.left+((rcWork.right-rcWork.left)-rcWnd.right)/2;
	} else {
		if (nMainWindowLeft<rcWork.left)
			nMainWindowLeft=rcWork.left;
		else if (nMainWindowLeft+rcWnd.right>rcWork.right)
			nMainWindowLeft=rcWork.right-rcWnd.right;
	}
	if (nMainWindowTop==CW_USEDEFAULT) {
		nMainWindowTop=rcWork.top+((rcWork.bottom-rcWork.top)-rcWnd.bottom)/2;
	} else {
		if (nMainWindowTop<rcWork.top)
			nMainWindowTop=rcWork.top;
		else if (nMainWindowTop+rcWnd.bottom>rcWork.bottom)
			nMainWindowTop=rcWork.bottom-rcWnd.bottom;
	}
	hwndMain=CreateWindow(MAIN_WINDOW_CLASS,TEXT("[}K"),
				WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
				nMainWindowLeft,nMainWindowTop,rcWnd.right,rcWnd.bottom,
				NULL,LoadMenu(hInst,MAKEINTRESOURCE(IDM_MAINMENU)),hInst,NULL);
	if (hwndMain==NULL) {
		MessageBox(NULL,TEXT("CEBhE쐬ł܂B"),NULL,MB_OK);
		return FALSE;
	}
	ShowWindow(hwndMain,nCmdShow);
	UpdateWindow(hwndMain);

	GetModuleFileName(hInst,szLessonWordsFileName,MAX_PATH);
	lstrcpy(GetFileNamePtr(szLessonWordsFileName),TEXT("words.txt"));

	hmenu=GetMenu(hwndMain);
	CheckMenuItem(hmenu,CM_SHOWKEYBOARD,MF_BYCOMMAND |
									(fShowKeyboard?MFS_CHECKED:MFS_UNCHECKED));

	while (GetMessage(&msg,NULL,0,0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	SaveSettings(szIniFileName);

	DIB_Destroy(&pdibWindow);
	DIB_Destroy(&pdibTitle);
	DIB_Destroy(&pdibKeyboard);
	DIB_Destroy(&pdibHand);
	if (hfontText!=NULL)
		DeleteObject(hfontText);
	if (ppszLessonWordList!=NULL)
		FreeLessonWords(ppszLessonWordList,nNumLessonWords);

	return msg.wParam;
}
